#ifdef USE_TI89
    #include "Lava.h"
    #undef KEY_UP
    #undef KEY_DOWN
    #undef KEY_RIGHT
    #undef KEY_LEFT
    #undef KEY_ESC
    #define LCD_W       160
    #define LCD_H       100//debug
#else
    #define LCD_W       160
    #define LCD_H       80
#endif

#define Y0              ((LCD_H-80)/2)
/*=======================================================
Name:CrazyBall
Ver:FINAL Tiny 2.5
COPYRIGHT:CSKSOFT 2004
=========================================================*/

void InitKeys();
void ShowSpeed();
void ShowError(addr str);

///Input Support//////////////////////////
#define FONT_W      6
#define FONT_H      12

//---------------------
#define MODE_STANTARD 0
#define MODE_EN_ONLY  1
#define MODE_NUM_ONLY  2
///////////////////////////////////////////

///Key Define//////////////////
#define UP_KEY      20
#define DOWN_KEY    21
#define RIGHT_KEY   22
#define LEFT_KEY    23

#define ENTER_KEY   13
#define ESC_KEY     27
#define PAGEUP_KEY  19
#define PAGEDW_KEY  14
///////////////////////////////
///GUI Interface///////////////

#define FORM_ANIM_DIS   0
#define FORM_ANIM_EN    1
#define FORM_DRAW_BUF   0x40
////////////////////////////////
#define AREA_BOTTOM     770
#define AREA_TOP        40
#define AREA_LEFT       40
#define AREA_RIGHT      1100

#define BLOCK_OFFSETX  2
#define BLOCK_OFFSETY  1

#define BLOCK_HEIGHT    5
#define BLOCK_WIDTH     10

#define WALL_TOP        60
#define WALL_LEFT       80
#define WALL_RIGHT      1070
#define WALL_BOTTOM     520
//////////////////////GainItem
#define BALL_RELIFE     1         //0000 0001
#define BALL_SRINK      2         //0000 0010
#define BALL_THROUGH    16        //0001 0000
#define BALL_FIRE       32        //0010 0000
#define BALL_MAG        64        //0100 0000
///^MixProperty
#define BALL_SUPER      65
#define BALL_SPEEDUP    129
#define BALL_SLOWDOWN   130
#define BALL_LIFE       131
#define BALL_KILL       132
#define BALL_DOUBLE     133

#define BALL_STKEXPAND  134
#define BALL_STKSRINK   135
#define BALL_FREEPASS   136

#define BALL_SUPEREYE   137
#define BALL_GOODFOOD   138
#define BALL_MAGIC      139
#define BALL_DADLUCK    140
#define BALL_RANDOM     141
///////////////////////////

#define STICK_HEIGHT    ((LCD_H-7)*10)
#define STICK_SPEED     50
#define STICK_LENGTH    180
#define STICK_MINLENGTH 80
#define STICK_MAXLENGTH 480

#define FIRE_CREATE     1
#define FIRE_MAINTAIN   2

char SaveFile[23] = { "/LavaData/CBallRec.ini" };

char FormAnim;
char NeedSave;
char FAST_SPEED; //= 25
char STD_SPEED;  //= 20
char SLOW_SPEED; //= 15
char ItemID = 0;

//^ImgObj
//BlockData Define
char Blocks[11][12];
addr ImgList[10];
addr fp;
char StageFile[30];
char KeyMap[4];
///////////////
//KeyMap[0]  <
//KeyMap[1]  >
//KeyMap[2]  P
///////////////


int vx, vy;
int TotalBlock;
long TotalScore;
long HighScores[3];
char RankNames[3][9];
char IsDock, IsAlive;
char UserName[10];
char CurStage, MaxStage, TotalStage;
char isEsc;
char Buff[5][9];
char MapType;
int Hits;
///////////////////
int DelayRate;
///////////////////
struct thisBall
{
    int life;
    int Strength;
    int speed;
    int MixProperty; //See PropertyDefine!
};

struct thisStick
{
    int Length;
    int lLength;
    int Left;
    int lLeft;
};

struct BallOBJ
{
    int x;
    int y;
    char isDock;
    int vx;
    int vy;
    int Bpox;
    int Bpoy;
    char visible;
};

struct ITEMOBJ
{
    int x;
    int y;
    int itemID;
};

struct thisBall tBall;
struct thisStick tStick;
struct ITEMOBJ gainITEM;
struct BallOBJ BallNum[2];

int Item[] =
{
    BALL_SPEEDUP,
    BALL_SLOWDOWN,
    BALL_MAG,
    BALL_RELIFE,
    BALL_SUPER,
    BALL_FIRE,
    BALL_STKEXPAND,
    BALL_SUPEREYE,
    BALL_THROUGH,
    BALL_DOUBLE
};

char Price[] =
{
    5,
    10,
    10,
    10,
    10,
    10,
    10,
    10,
    15,
    20
};

char ball[] =
{
    0x60, 0xd0, 0xf0, 0x60
};
//BLOCK IMG///////////////////////////////////
char block1[] =
{
    0x7f, 0x80, 0xaa, 0xc0, 0xd5, 0x40, 0xaa, 0xc0, 0x7f, 0x80
};
char block2[] =
{
    0x7f, 0x80, 0x80, 0x40, 0xbf, 0x40, 0x80, 0x40, 0x7f, 0x80
};
char block3[] =
{
    0x00, 0x00, 0x7f, 0xc0, 0x7f, 0xc0, 0x7f, 0xc0, 0x7f, 0xc0
};
char block4[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};
char block5[] =
{
    0x7b, 0x80, 0xf7, 0xc0, 0xfb, 0xc0, 0xfb, 0xc0, 0x77, 0x80
};

char rd_down[] =
{
    0x8c, 0x40, 0x52, 0x80, 0xad, 0x40, 0x52, 0x80, 0x21, 0x00
};
char rd_up[] =
{
    0x21, 0x00, 0x52, 0x80, 0xad, 0x40, 0x52, 0x80, 0x8c, 0x40
};
char rd_le[] =
{
    0x24, 0x80, 0x49, 0x00, 0x92, 0x00, 0x49, 0x00, 0x24, 0x80
};
char rd_ri[] =
{
    0x49, 0x00, 0x24, 0x80, 0x12, 0x40, 0x24, 0x80, 0x49, 0x00
};
//////////////////////////////////////////////
//ITEM IMG////////////////////////////////////
char ITEM_Mag[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x12, 0x00, 0x00, 0x00, 0x12, 0x00, 0x00, 0x00, 0x0c, 0x00, 0xff, 0xff, 0xff, 0xe0, 0x80, 0x00, 0x00, 0x20, 0xff, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x00, 0x00
};
char ITEM_Relife[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x40, 0x00, 0x00, 0x40, 0xa0, 0x00, 0x00, 0x20, 0x47, 0xff, 0xc0, 0x10, 0x87, 0xff, 0xc0, 0x0b, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xf0
};
char ITEM_LIFE[] =
{
    0xff, 0xff, 0xff, 0xe0, 0x80, 0x00, 0x00, 0x20, 0x80, 0x04, 0x97, 0x20, 0x80, 0x0c, 0x94, 0xa0, 0x80, 0x24, 0x94, 0xa0, 0x86, 0x74, 0x94, 0xa0, 0x8d, 0x24, 0x97, 0x20, 0x8f, 0x04, 0x94, 0x20, 0x86, 0x0e, 0x64, 0x20, 0x80, 0x00, 0x00, 0x20, 0xff, 0xff, 0xff, 0xe0
};
char ITEM_SUPER[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x19, 0x2e, 0x7b, 0x80, 0x25, 0x29, 0x42, 0x40, 0x21, 0x29, 0x42, 0x40, 0x19, 0x29, 0x73, 0x80, 0x05, 0x2e, 0x43, 0x00, 0xc5, 0x28, 0x42, 0xa0, 0x98, 0xc8, 0x7a, 0x60, 0xff, 0xff, 0xff, 0xe0, 0x00, 0x00, 0x00, 0x00
};
char ITEM_DOWN[] =
{
    0xff, 0xff, 0xff, 0xe0, 0x80, 0x00, 0x00, 0x20, 0x84, 0x45, 0xc8, 0xa0, 0x88, 0x89, 0x2a, 0xa0, 0x91, 0x11, 0x2a, 0xa0, 0xa2, 0x21, 0x2a, 0xa0, 0x91, 0x11, 0x2a, 0xa0, 0x88, 0x89, 0x25, 0x20, 0x84, 0x45, 0xc5, 0x20, 0x80, 0x00, 0x00, 0x20, 0xff, 0xff, 0xff, 0xe0
};
char ITEM_STKEXPAND[] =
{
    0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x02, 0x00, 0x08, 0x00, 0x01, 0x00, 0x1f, 0xf9, 0xff, 0x80, 0x30, 0x09, 0x00, 0xc0, 0x6f, 0xf9, 0xff, 0x60, 0x30, 0x09, 0x00, 0xc0, 0x1f, 0xf9, 0xff, 0x80, 0x08, 0x00, 0x01, 0x00, 0x04, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00
};
char ITEM_FIRE[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x29, 0xff, 0xff, 0x80, 0x11, 0x00, 0x00, 0x80, 0x29, 0x3a, 0xb8, 0x80, 0x07, 0x13, 0x90, 0x80, 0x01, 0x12, 0x90, 0x80, 0x01, 0xff, 0xff, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};
char ITEM_PASS[] =
{
    0xff, 0xff, 0xff, 0xe0, 0x80, 0x00, 0x00, 0x20, 0x91, 0x7a, 0x2f, 0xa0, 0x99, 0x42, 0x22, 0x20, 0x99, 0x41, 0x42, 0x20, 0x95, 0x70, 0x82, 0x20, 0x93, 0x41, 0x42, 0x20, 0x93, 0x42, 0x22, 0x20, 0x91, 0x7a, 0x22, 0x20, 0x80, 0x00, 0x00, 0x20, 0xff, 0xff, 0xff, 0xe0
};
char ITEM_UP[] =
{
    0xff, 0xff, 0xff, 0xe0, 0x80, 0x00, 0x00, 0x20, 0x91, 0x10, 0x97, 0x20, 0x88, 0x88, 0x94, 0xa0, 0x84, 0x44, 0x94, 0xa0, 0x82, 0x22, 0x94, 0xa0, 0x84, 0x44, 0x97, 0x20, 0x88, 0x88, 0x94, 0x20, 0x91, 0x10, 0x64, 0x20, 0x80, 0x00, 0x00, 0x20, 0xff, 0xff, 0xff, 0xe0
};
char ITEM_THROUGH[] =
{
    0xff, 0xff, 0xff, 0xe0, 0x80, 0x00, 0x00, 0x20, 0x87, 0xff, 0x9c, 0x20, 0x80, 0x00, 0x00, 0x20, 0x87, 0xfd, 0xfc, 0x20, 0x80, 0x00, 0x00, 0x20, 0x87, 0xef, 0xfc, 0x20, 0x80, 0x00, 0x00, 0x20, 0x86, 0x7f, 0xfc, 0x20, 0x80, 0x00, 0x00, 0x20, 0xff, 0xff, 0xff, 0xe0
};
char ITEM_STKSRINK[] =
{
    0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x10, 0x00, 0x00, 0x80, 0x20, 0x00, 0xff, 0xc0, 0x7f, 0xe0, 0x00, 0x60, 0xc0, 0x00, 0xff, 0xb1, 0xbf, 0xe0, 0x00, 0x60, 0xc0, 0x00, 0xff, 0xc0, 0x7f, 0xe0, 0x00, 0x80, 0x20, 0x00, 0x01, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00
};
char ITEM_KILL[] =
{
    0x1f, 0xe0, 0x00, 0x00, 0x00, 0x20, 0x10, 0x00, 0x00, 0x00, 0x40, 0x08, 0x00, 0x00, 0x00, 0x40, 0x08, 0x00, 0x00, 0x00, 0x40, 0x08, 0x00, 0x00, 0x00, 0x4c, 0xc8, 0x00, 0x00, 0x00, 0x2c, 0xd0, 0x00, 0x00, 0x00, 0x20, 0x30, 0x00, 0x00, 0x00, 0x13, 0x24, 0x00, 0x00, 0x00, 0x0b, 0x59, 0x9c, 0x9d, 0x40, 0xd4, 0xe1, 0x51, 0x49, 0x40, 0x75, 0xb1, 0x59, 0xc9, 0xc0, 0x4f, 0x51, 0x51, 0x49, 0x40, 0x19, 0xc1, 0x9d, 0x49, 0x40
};
char ITEM_DOUBLE[] =
{
    0x00, 0x01, 0x06, 0x00, 0x00, 0x00, 0x01, 0x8b, 0x00, 0x00, 0x00, 0x03, 0xcf, 0x00, 0x00, 0x00, 0x0d, 0x86, 0x00, 0x00, 0x18, 0x71, 0x00, 0x00, 0x00, 0x2c, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x71, 0x00, 0x00, 0x00, 0x00, 0x0d, 0x86, 0x00, 0x00, 0x00, 0x03, 0xcb, 0x00, 0x00, 0x00, 0x01, 0x8f, 0x00, 0x00, 0x00, 0x01, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};
char ITEM_GOODFOOD[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xc1, 0xc2, 0x50, 0x00, 0x0f, 0xe0, 0x85, 0x70, 0x00, 0x13, 0xf0, 0x87, 0x50, 0x00, 0x33, 0xf9, 0xc5, 0x50, 0x00, 0x3f, 0xf8, 0x00, 0x00, 0x00, 0x7f, 0xfd, 0xe9, 0x42, 0x00, 0x7f, 0xfd, 0x09, 0x42, 0x00, 0x7f, 0xfd, 0x09, 0x42, 0x00, 0x3b, 0xb9, 0xc9, 0x42, 0x00, 0x3c, 0x79, 0x09, 0x42, 0x00, 0x1f, 0xf1, 0x09, 0x42, 0x00, 0x0f, 0xe1, 0x06, 0x7b, 0xc0, 0x07, 0xc0, 0x00, 0x00, 0x00
};
char ITEM_RANDOM[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x7f, 0xff, 0xff, 0xfc, 0x00, 0x40, 0x81, 0x02, 0x04, 0x00, 0x4c, 0x99, 0x32, 0x64, 0x00, 0x52, 0xa5, 0x4a, 0x94, 0x00, 0x42, 0x85, 0x0a, 0x14, 0x00, 0x44, 0x89, 0x12, 0x24, 0x00, 0x48, 0x91, 0x22, 0x44, 0x00, 0x48, 0x91, 0x22, 0x44, 0x00, 0x40, 0x81, 0x02, 0x04, 0x00, 0x48, 0x91, 0x22, 0x44, 0x00, 0x40, 0x81, 0x02, 0x04, 0x00, 0x7f, 0xff, 0xff, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

char ITEM_MAGIC[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x04, 0x21, 0x00, 0x00, 0x03, 0x0e, 0x03, 0x80, 0x00, 0x00, 0x04, 0x01, 0x20, 0x00, 0x00, 0x00, 0x00, 0x70, 0x00, 0x00, 0x10, 0x00, 0x20, 0x00, 0x02, 0x38, 0x0c, 0x00, 0x00, 0x00, 0x10, 0x3c, 0x00, 0x00, 0x08, 0x00, 0xf0, 0x00, 0x00, 0x1c, 0x03, 0xc0, 0x00, 0x00, 0x08, 0x0f, 0x02, 0x91, 0x00, 0x00, 0x3c, 0x03, 0xaa, 0x80, 0x00, 0xf0, 0x02, 0xbb, 0x80, 0x01, 0xc0, 0x02, 0xa9, 0x80
};

char ITEM_SUPEREYE[] =
{
    0x00, 0x03, 0xc0, 0x00, 0x00, 0x00, 0x0d, 0x30, 0x00, 0x00, 0x05, 0x50, 0x0a, 0xa0, 0x00, 0x08, 0x1e, 0xf8, 0x10, 0x00, 0x00, 0x3d, 0xfc, 0x00, 0x00, 0x08, 0x3e, 0xfc, 0x10, 0x00, 0x00, 0x3f, 0x7c, 0x00, 0x00, 0x08, 0x3f, 0x7c, 0x10, 0x00, 0x00, 0x1f, 0x78, 0x00, 0x00, 0x05, 0x50, 0x0a, 0xa0, 0x00, 0x00, 0x0c, 0x1c, 0x00, 0x00, 0x00, 0x03, 0xee, 0x00, 0x00, 0x00, 0x00, 0x17, 0x00, 0x00, 0x00, 0x00, 0x0b, 0x80, 0x00
};
char ITEM_BADLUCK[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x01, 0xc0, 0x62, 0x60, 0x00, 0x01, 0xc0, 0x55, 0x50, 0x00, 0x03, 0x60, 0x65, 0x50, 0x00, 0x07, 0x70, 0x57, 0x50, 0x00, 0x07, 0x70, 0x65, 0x60, 0x00, 0x0f, 0x78, 0x00, 0x00, 0x00, 0x1f, 0xfc, 0x45, 0x25, 0x00, 0x3f, 0x7e, 0x45, 0x55, 0x00, 0x3f, 0xfe, 0x45, 0x46, 0x00, 0x00, 0x00, 0x45, 0x55, 0x00, 0x00, 0x00, 0x72, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};
///////////////////////////////////////////

//Sence Elements////////////////////////
char Sence_ball[] =
{
    0xc4, 0x88, 0x00, 0xaa, 0x88, 0x00, 0xce, 0x88, 0x80, 0xaa, 0x88, 0x00, 0xca, 0xee, 0x80
};

char Sence_stg[] =
{
    0x6e, 0x46, 0xe0, 0x84, 0xa8, 0x80, 0x44, 0xee, 0xe8, 0x24, 0xaa, 0x80, 0xc4, 0xa6, 0xe8
};
char Sence_item[] =
{
    0xee, 0xea, 0x00, 0x44, 0x8e, 0x00, 0x44, 0xee, 0x80, 0x44, 0x8a, 0x00, 0xe4, 0xea, 0x80
};
char Sence_scro[] =
{
    0x66, 0x4c, 0xe0, 0x88, 0xaa, 0x80, 0x48, 0xac, 0xe8, 0x28, 0xaa, 0x80, 0xc6, 0x4a, 0xe8
};

////////////////////////////////////////

/////////////////////////////////////////

char logo1[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7d, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x71, 0x90, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x79, 0x48, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x49, 0xd0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x4a, 0x50, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x41, 0x49, 0xd0, 0x01, 0xe0, 0x0e, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xbc, 0x15, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x06, 0x30, 0x15, 0x7e, 0x6d, 0x00, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x06, 0x30, 0x2e, 0xdd, 0xb2, 0x01, 0xf8, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x06, 0x30, 0x70, 0x7a, 0xad, 0x03, 0x18, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x06, 0x30, 0x40, 0xdf, 0xd6, 0x06, 0x18, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x06, 0x30, 0x6a, 0x6f, 0xe8, 0x0e, 0x01, 0x9c, 0x1e, 0x3f, 0xec, 0x0d, 0xbc, 0x07, 0x86, 0x30, 0xc3, 0x7b, 0xd4, 0x0c, 0x01, 0xfc, 0x3f, 0x3f, 0xec, 0x1d, 0xfe, 0x0f, 0xc6, 0x30, 0xb8, 0xee, 0xe8, 0x1c, 0x01, 0xcc, 0x73, 0x01, 0xc6, 0x19, 0xc6, 0x1c, 0xc6, 0x30, 0xe6, 0xdf, 0xd0, 0x18, 0x01, 0x8c, 0xe3, 0x01, 0x86, 0x19, 0x83, 0x38, 0xc6, 0x30, 0xd6, 0xbb, 0xe8, 0x18, 0x01, 0x80, 0xc3, 0x03, 0x03, 0x31, 0x83, 0x30, 0xc6, 0x30, 0x7f, 0xff, 0xd0, 0x18, 0x01, 0x80, 0xc3, 0x07, 0x03, 0x31, 0x83, 0x30, 0xc6, 0x30, 0x76, 0xdf, 0xa0, 0x18, 0x19, 0x80, 0xc3, 0x0e, 0x01, 0xe1, 0x83, 0x30, 0xc6, 0x30, 0x7f, 0xff, 0xc0, 0x0c, 0x39, 0x80, 0xe3, 0x1c, 0x01, 0xe1, 0x86, 0x38, 0xc6, 0x30, 0x3b, 0xf9, 0x40, 0x0f, 0xf1, 0x80, 0x7f, 0xbf, 0xe0, 0xc1, 0xfe, 0x1f, 0xe6, 0x30, 0x1f, 0xde, 0x80, 0x03, 0xc1, 0x80, 0x3d, 0xbf, 0xe0, 0xc1, 0xf8, 0x0f, 0x66, 0x30, 0x0f, 0xfc, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x01, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00
};
////////////////////////////


char lava_GetWordMode = 0;
int GetWord(char mode)
{
    // mode
    // 0 - ENG
    // 1 - NUM
    // 2 - CHS
    // 3 - LAST
    int ch;
    mode = mode &3;
    if (mode == 3)
    {
        mode = lava_GetWordMode;
    }
    else
    {
        lava_GetWordMode = mode;
    }
    ch = getchar();
    if (mode == 1)
    {
        if (ch == 'b')
        {
            return '1';
        }
        if (ch == 'n')
        {
            return '2';
        }
        if (ch == 'm')
        {
            return '3';
        }
        if (ch == 'g')
        {
            return '4';
        }
        if (ch == 'h')
        {
            return '5';
        }
        if (ch == 'j')
        {
            return '6';
        }
        if (ch == 't')
        {
            return '7';
        }
        if (ch == 'y')
        {
            return '8';
        }
        if (ch == 'u')
        {
            return '9';
        }
    }
    return ch;
}

void CreateForm(int x0, int y0, int x1, int y1, int style, addr strTitle)
{
    /* ========================
    #define FORM_ANIM_DIS   0
    #define FORM_ANIM_EN    1
    #define FORM_DRAW_BUF   0x40
    COPYRIGHT CSKSOFT
    ===========================*/
    char i, mode;
    int hh;
    //
    hh = (y1 - y0 + 1) / 2;
    y1 = y0 + hh;
    i = 0;
    mode = 0x00;
    if (style & FORM_DRAW_BUF)
    {
        mode = 0x40;
    }
    if (!(style & FORM_ANIM_EN))
    {
        i = (hh - 2) & ~1;
        Box(x0+2, y1-i-0, x1-2, y1+i-1, 1, 0);
    }
    for (;;)
    {
        Box(x0+2, y1-i-2, x1-2, y1-i-1, 1, 1);
        Box(x0+2, y1+i+0, x1-2, y1+i+1, 1, 1);
        if (i >= hh - 2)
        {
            break;
        }
        if (DelayRate >= 8)
        {
            Delay(DelayRate / 2);
        }
        Box(x0+2, y1-i-2, x1-2, y1-i-1, 1, 0);
        Box(x0+2, y1+i+0, x1-2, y1+i+1, 1, 0);
        i = i + 2;
    }
    if (style & FORM_DRAW_BUF)
    {
        Block(x0+2, y1-i-0, x1-2, y1+i-1, 0);
        Block(x0+2, y1-i-2, x1-2, y1-i-1, 1);
        Block(x0+2, y1+i+0, x1-2, y1+i+1, 1);
    }
    Line(x0+0, y1-i-2, x0+0, y1-i+1, mode|1);
    Line(x0+1, y1-i-2, x0+1, y1-i+1, mode|1);
    Line(x1-0, y1-i-2, x1-0, y1-i+1, mode|1);
    Line(x1-1, y1-i-2, x1-1, y1-i+1, mode|1);
    //
    Line(x0+0, y1+i-2, x0+0, y1+i+1, mode|1);
    Line(x0+1, y1+i-2, x0+1, y1+i+1, mode|1);
    Line(x1-0, y1+i-2, x1-0, y1+i+1, mode|1);
    Line(x1-1, y1+i-2, x1-1, y1+i+1, mode|1);

    if (strTitle != 0)
    {
        TextOut(x0 + 5, y0 + 3, strTitle, mode^0x41);
        Line(x0 + 2, y0 + FONT_H + 3, x1 - 2, y0 + FONT_H + 3, mode|1);
    }
}

int CreateMenu(int x0, int y0, int count, int curr)
{
    char ch, mode;
    int prev, next;
    mode = 0x40;
    if (curr & FORM_DRAW_BUF)
    {
        curr = curr & ~FORM_DRAW_BUF;
        mode = 0x00;
    }
    
    for (;;)
    {
        if (curr < 0)
        {
            curr = count - 1;
        }
        if (curr >= count)
        {
            curr = 0;
        }
        //
        prev = curr - 1;
        if (prev < 0)
        {
            prev = count - 1;
        }
        if (prev >= count)
        {
            prev = 0;
        }
        //
        next = curr + 1;
        if (next < 0)
        {
            next = count - 1;
        }
        if (next >= count)
        {
            next = 0;
        }

        TextOut(x0, y0 + FONT_H * 0, Buff[prev], mode|1);
        TextOut(x0, y0 + FONT_H * 1, Buff[curr], mode|9);
        TextOut(x0, y0 + FONT_H * 2, Buff[next], mode|1);
        if (mode==0)
        {
            Refresh();
        }
        ch = getchar();
        if (ch == ESC_KEY)
        {
            return -1;
        }
        if (ch == ENTER_KEY)
        {
            break;
        }
        if (ch == UP_KEY)
        {
            curr--;
        }
        if (ch == DOWN_KEY)
        {
            curr++;
        }
    }
    return curr;
}

int CreateMoveBar(int x, int y, int length, int max, int pos)
{
    char ch;
    
    Box(x, y, x + length, y + 6, 1, 0);
    Line(x, y + 3, x + length, y + 3, 1);

    Line(x, y + 7, x, y + 11, 1);
    Line(x + (length - 4) / 2, y + 7, x + (length - 4) / 2, y + 11, 1);
    Line(x + (length - 4), y + 7, x + (length - 4), y + 11, 1);
    Line(x + (length - 4) / 4, y + 7, x + (length - 4) / 4, y + 9, 1);
    Line(x + (length - 4) *3 / 4, y + 7, x + (length - 4) *3 / 4, y + 9, 1);

    TextOut(x, y + 11, "0", 0x43);
    TextOut(x + (length - 4) / 2-5, y + 11, "50", 0x43);
    TextOut(x + (length - 4) - 10, y + 11, "100", 0x43);
    Box(pos *(length - 4) / max + x, y, pos *(length - 4) / max + 4+x, y + 6, 1, 2);
    for (;;)
    {
        ch = getchar();
        Box(pos *(length - 4) / max + x, y, pos *(length - 4) / max + 4+x, y + 6, 1, 2);
        if (ch == LEFT_KEY)
        {
            if ( --pos < 0) pos = 0;
        }
        if (ch == RIGHT_KEY)
        {
            if ( ++pos > max) pos = max;
        }
        if (ch == ENTER_KEY || ch == ESC_KEY)
        {
            break;
        }
        Box(pos *(length - 4) / max + x, y, pos *(length - 4) / max + 4+x, y + 6, 1, 2);
    }
    return pos;
}

void Input(char x, char y, addr buf, char max_len)
{
    int ch;
    char _x, len;
    char mode;
    mode = 2;   //Ĭ뷨
    *buf = 0;
    len = 0;
    for (;;)
    {
        Box(x, y, x+max_len*FONT_W+1, y+11, 1, 0);
        TextOut(x, y, buf, 0x41);
        _x = len*FONT_W + x;
        Box(_x, y+1, _x+1, y+10, 1, 1);
        ch = GetWord(mode);
        mode = 3;   //ϴ뷨
        if (ch == 23 || ch == 29)
        {// /F2, ɾַ
            if (len > 0)
            {
                if (--len>0 && (*(buf+len)&0x80))
                {
                    --len;
                }
            }
            *(buf+len) = 0;
            continue;
        }
        if (ch & 0x80)
        {
            if (len < max_len-1)
            {
                *(buf+len++) = ch&255;
                *(buf+len++) = ch>>8;
                *(buf+len) = 0;
            }
            continue;
        }
        if (isprint(ch))
        {
            if (len < max_len)
            {
                *(buf+len++) = ch;
                *(buf+len) = 0;
            }
            continue;
        }
        if (ch == 13 )
        {
            if (len > 0)
            {
                return;
            }
            ch = 27;
        }
        if (ch == 27)
        {
            if (len == 0)
            {
                strcpy(buf, "NoName");
                *(buf+max_len) = 0;
            }
            return;
        }
        if (len == max_len)
        {
            Beep();
        }
    }
}

void SaveProfile()
{
    fp = fopen(SaveFile, "rb+");
    if (fp == 0)
    {
        fp = fopen(SaveFile,"wb");
    }
    if (fp)
    {
        fseek(fp, 0, SEEK_SET);
        fwrite("CBINI", 1, 6, fp);
        //
        Buff[0][0] = FAST_SPEED;
        Buff[0][1] = STD_SPEED;
        Buff[0][2] = SLOW_SPEED;
        Buff[0][3] = DelayRate;
        Buff[0][4] = MaxStage;
        Buff[0][5] = CurStage;
        fwrite(Buff[0], 1, 6, fp);
        fwrite(UserName, 1, 10, fp);
        fwrite(KeyMap, 1, 4, fp);
        fclose(fp);
    }
}

void SaveRanking()
{
    char i;
    fp = fopen(SaveFile, "rb+");
    if (fp)
    {
        fseek(fp, 26, SEEK_SET);
        fwrite(RankNames, 1, sizeof(RankNames), fp);
        fwrite(HighScores, 1, sizeof(HighScores), fp);
        fclose(fp);
    }
}

void ClearRanking()
{
    char i;
    for (i = 0; i < 3; i++)
    {
        HighScores[i] = 0;
        strcpy(RankNames[i], "NONAME");
    }
}

void LoadProfile()
{
    char i;

    fp = fopen(SaveFile, "rb");
    do
    {
        if (fp != 0)
        {
            // ini: 6+5+10+5 = 26
            if (!fread(Buff, 1, 6, fp))
                break;
            Buff[0][6] = 0;
            if (strcmp(Buff, "CBINI") != 0)
            {
                break;
            }
            if (!fread(Buff, 1, 6, fp))
                break;
            FAST_SPEED = Buff[0][0];
            STD_SPEED  = Buff[0][1];
            SLOW_SPEED = Buff[0][2];
            DelayRate  = Buff[0][3];
            MaxStage   = Buff[0][4];
            CurStage   = Buff[0][5];
            if (CurStage > MaxStage)
            {
                CurStage = MaxStage;
            }
            if (!fread(UserName, 1, 10, fp))
                break;
            if (!fread(KeyMap, 1, 4, fp))
                break;
            if (!fread(RankNames, 1, sizeof(RankNames), fp))
                break;
            if (!fread(HighScores, 1, sizeof(HighScores), fp))
                break;
            fclose(fp);
            return; //ȡɹ
        }
    } while(0);
    if (fp != 0)
    {
        fclose(fp);
        ShowError("Bad CBallRec");
        fp = 0;
    }
    if (fp == 0)
    {
        CurStage = 1;
        MaxStage = 1;
        DelayRate  = 26;
        FAST_SPEED = 25;
        STD_SPEED  = 20;
        SLOW_SPEED = 15;
        CreateForm(3, Y0+3, 154, Y0+77, FORM_ANIM_EN, "Welcome to CrazyBall!");
        TextOut(10, Y0+8+FONT_H * 1, "To Get Licence,", 0x41);
        TextOut(10, Y0+8+FONT_H * 2, "Please input your name.", 0x41);
        TextOut(10, Y0+8+FONT_H * 4, "Your name:", 0x41);
        Line(70, Y0+8+FONT_H * 5, 70+FONT_W * 10, Y0+8+FONT_H * 5, 1);
        Input(71, Y0+8+FONT_H * 4, UserName, 9);

        ShowSpeed();
        InitKeys();
        SaveProfile();
        //
        ClearRanking();
        SaveRanking();
    }
}

void InitKeys()
{
    KeyMap[0] = LEFT_KEY;   //
    KeyMap[1] = RIGHT_KEY;  //
    KeyMap[2] = DOWN_KEY;   //ͣ˵
    KeyMap[3] = UP_KEY;     //
}

void InitImageBlock()
{
    ImgList[0] = block1;
    ImgList[1] = block2;
    ImgList[2] = block3;
    ImgList[3] = block4;
    ImgList[4] = block5;
    ImgList[5] = NULL;
    ImgList[6] = rd_down;
    ImgList[7] = rd_up;
    ImgList[8] = rd_le;
    ImgList[9] = rd_ri;
}

void InitImageItem()
{
    ImgList[0] = ITEM_UP;          //height=11
    ImgList[1] = ITEM_DOWN;        //height=11
    ImgList[2] = ITEM_Mag;         //height=11
    ImgList[3] = ITEM_Relife;      //height=11
    ImgList[4] = ITEM_SUPER;       //height=11
    ImgList[5] = ITEM_FIRE;        //height=11
    ImgList[6] = ITEM_STKEXPAND;   //height=11
    ImgList[7] = ITEM_SUPEREYE;    //height=14
    ImgList[8] = ITEM_THROUGH;     //height=11
    ImgList[9] = ITEM_DOUBLE;      //height=14
}

//  ؿ
void DrawSence()
{
    ClearScreen();
    Rectangle(1, 0, 112, LCD_H-1, 1);
    Rectangle(116, LCD_H-46, 158, LCD_H-1, 1);
    Line(118, LCD_H-21, 156, LCD_H-21, 0x41);
    WriteBlock(116, 1, 17, 5, 1, Sence_ball);
    WriteBlock(117, LCD_H-54, 21, 5, 1, Sence_stg);
    WriteBlock(119, LCD_H-44, 17, 5, 1, Sence_item);
    WriteBlock(119, LCD_H-18, 21, 5, 1, Sence_scro);
    Refresh();
}

void DrawLife(int Life)
{
    int i;
    Block(119, 9, 156, 19, 0);
    if (Life > 0 && Life <= 7)
    {
        for (i = 0; i < Life; i++)
        {
            WriteBlock(119+i * 5, 9, 4, 4, 1, ball);
        }
    }

    if (Life > 7 && Life <= 14)
    {
        for (i = 0; i < 7; i++)
        {
            WriteBlock(119+i * 5, 9, 4, 4, 1, ball);
        }
        for (i = 0; i < Life - 7; i++)
        {
            WriteBlock(119+i * 5, 15, 4, 4, 1, ball);
        }
    }
    Refresh();
}

void ScoreToBuff(long score)
{
    if( score>=10000 )
    {
        sprintf(Buff, "%d", (int)(score / 10000));
        sprintf(&Buff[0][0]+strlen(Buff), "%04d", (int)(score % 10000));
    }
    else
    {
        sprintf(Buff, "%d", (int)score);
    }
    
}

void DrawScore()
{
    if (TotalScore > 999999)
    {
        return ;
    }
    Block(122, LCD_H-12, 155, LCD_H-3, 0);
    ScoreToBuff(TotalScore);
    TextOut(122, LCD_H-13, Buff, 3);
}

void DrawBlock(int x, int y, int type)
{
    int i, j;
    if (type)
    {
        WriteBlock(BLOCK_OFFSETX + x * BLOCK_WIDTH, BLOCK_OFFSETY + y * BLOCK_HEIGHT, BLOCK_WIDTH, BLOCK_HEIGHT, 1, ImgList[type - 1]);
    }
    else
    {
        if (tBall.MixProperty &BALL_FIRE)
        {
            for (i = x - 1; i <= x + 1; i++)
            {
                for (j = y - 1; j <= y + 1; j++)
                {
                    if (i >= 0 && j >= 0 && i < 11 && j < 11)
                    {
                        Block(BLOCK_OFFSETX + i * BLOCK_WIDTH, BLOCK_OFFSETY + j * BLOCK_HEIGHT, BLOCK_OFFSETX + i * BLOCK_WIDTH + BLOCK_WIDTH - 1, BLOCK_OFFSETY + j * BLOCK_HEIGHT + BLOCK_HEIGHT - 1, 0);
                        if ((Blocks[i][j] < 3 && Blocks[i][j] > 0) || Blocks[i][j] == 4)
                        {
                            TotalBlock--;
                        }
                        Blocks[i][j] = 0;
                    }
                }
            }
        }
        else
        {
            Block(BLOCK_OFFSETX + x * BLOCK_WIDTH, BLOCK_OFFSETY + y * BLOCK_HEIGHT, BLOCK_OFFSETX + x * BLOCK_WIDTH + BLOCK_WIDTH - 1, BLOCK_OFFSETY + y * BLOCK_HEIGHT + BLOCK_HEIGHT - 1, 0);
        }
    }
}

int LoadBlock(int stage)
{
    int i, j;
    char buffer[2];
    fp = fopen(StageFile, "rb");
    if (fp != 0)
    {
        for (i = 0; i < 11; i++)
        {
            for (j = 0; j < 11; j++)
            {
                Blocks[i][j] = 255;
            }
        }

        if (fseek(fp, (stage - 1) *121+20, SEEK_SET) ==  - 1)
        {
            fclose(fp);
            return  - 2;
        }

        TotalBlock = 0;

        for (i = 0; i < 11; i++)
        {
            for (j = 0; j < 11; j++)
            {
                if (fread(buffer, 1, 1, fp) == 0)
                {
                    fclose(fp);
                    Beep();
                    return  - 3;
                }
                Blocks[i][j] = buffer[0];

                DrawBlock(i, j, Blocks[i][j]);
                if ((Blocks[i][j] > 0 && Blocks[i][j] < 3) || Blocks[i][j] == 4)
                {
                    TotalBlock++;
                }
            }
        }
    }
    fclose(fp);
    return 1;
}

void LoadStage(int stage)
{
    tBall.MixProperty = 0;
    Box(1, 0, 111, LCD_H, 1, 1);
    TextOut(30, 40, "Loading...", 0x42);
    LoadBlock(stage);
    Delay(50);
    //
    Block(146, LCD_H-58, 156, LCD_H-48, 0);
    sprintf(Buff, "%d", stage);
    TextOut(140, LCD_H-58, Buff, 1);
    DrawScore();
    Refresh();
}

void CreatItem(int y)
{
    // BALL_RELIFE  1         //0000 0001
    // BALL_THROUGH 16        //0001 0000
    // BALL_FIRE    32        //0010 0000
    // BALL_MAG     64        //0100 0000
    ///^MixProperty
    // BALL_SUPER           65
    // BALL_SPEEDUP         129
    // BALL_SLOWDOWN        130
    // BALL_LIFE            131
    // BALL_KILL            133
    // BALL_SRINK           134

    // BALL_STKEXPAND          135
    // BALL_STKSRINK           136
    // BALL_FREEPASS           137
    // BALL_SUPEREYE           138
    // BALL_GOODFOOD           139
    // BALL_MAGIC              140
    // BALL_DADLUCK            141
    // BALL_RANDOM             142
    int tpitem;
    if (gainITEM.itemID)
    {
        return ;
    }
    tpitem = rand() % 701;

    if (tpitem >= 60 &tpitem < 70)
    {
        gainITEM.itemID = BALL_RELIFE;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_Relife);
    }
    if (tpitem >= 70 &tpitem < 80)
    {
        gainITEM.itemID = BALL_THROUGH;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_THROUGH);
    }
    if (tpitem >= 80 &tpitem < 90)
    {
        gainITEM.itemID = BALL_FIRE;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_FIRE);
    }
    if (tpitem >= 90 &tpitem < 100)
    {
        gainITEM.itemID = BALL_MAG;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_Mag);
    }
    if (tpitem >= 100 &tpitem < 110)
    {
        gainITEM.itemID = BALL_SUPER;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_SUPER);
    }
    if (tpitem >= 110 &tpitem < 120)
    {
        gainITEM.itemID = BALL_SPEEDUP;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_UP);
    }
    if (tpitem >= 130 &tpitem < 140)
    {
        gainITEM.itemID = BALL_SLOWDOWN;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_DOWN);

    }
    if (tpitem >= 140 &tpitem < 150)
    {
        gainITEM.itemID = BALL_DOUBLE;
        WriteBlock(122, LCD_H-38, 34, 14, 1, ITEM_DOUBLE);
    }

    if (tpitem >= 150 &tpitem < 160)
    {
        gainITEM.itemID = BALL_STKEXPAND;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_STKEXPAND);
    }
    if (tpitem >= 160 &tpitem < 170)
    {
        gainITEM.itemID = BALL_STKSRINK;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_STKSRINK);
    }

    if (tpitem >= 170 &tpitem < 175)
    {
        gainITEM.itemID = BALL_LIFE;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_LIFE);

    }
    if (tpitem >= 175 &tpitem < 180)
    {
        gainITEM.itemID = BALL_KILL;
        WriteBlock(122, LCD_H-38, 34, 14, 1, ITEM_KILL);
    }
    if (tpitem >= 180 &tpitem < 185)
    {
        gainITEM.itemID = BALL_FREEPASS;
        WriteBlock(122, LCD_H-38, 28, 11, 1, ITEM_PASS);

    }
    if (tpitem >= 185 &tpitem < 188)
    {
        gainITEM.itemID = BALL_GOODFOOD;
        WriteBlock(122, LCD_H-38, 34, 14, 1, ITEM_GOODFOOD);

    }
    if (tpitem >= 189 &tpitem < 194)
    {
        gainITEM.itemID = BALL_MAGIC;
        WriteBlock(122, LCD_H-38, 34, 14, 1, ITEM_MAGIC);

    }
    if (tpitem >= 195 &tpitem < 205)
    {
        gainITEM.itemID = BALL_SUPEREYE;
        WriteBlock(122, LCD_H-38, 34, 14, 1, ITEM_SUPEREYE);

    }
    if (tpitem >= 205 &tpitem < 210)
    {
        gainITEM.itemID = BALL_DADLUCK;
        WriteBlock(122, LCD_H-38, 34, 14, 1, ITEM_BADLUCK);

    }
    if (tpitem >= 210 &tpitem < 220)
    {
        gainITEM.itemID = BALL_RANDOM;
        WriteBlock(122, LCD_H-38, 34, 14, 1, ITEM_RANDOM);

    }
    if (gainITEM.itemID)
    {
        gainITEM.y = y;
        gainITEM.x = WALL_LEFT + rand() % (WALL_RIGHT - WALL_LEFT + 1);
    }
}

void Gain(int item)
{
    int tItem;
    int i, j;
    tItem = item;
GAIN_START:
    if (tItem <= BALL_MAG)
    {
        tBall.MixProperty = tBall.MixProperty | item;
        return;
    }
    if (tItem == BALL_SUPER)
    {
        tBall.Strength = 3;
        return;
    }
    if (tItem == BALL_SPEEDUP)
    {
        BallNum[0].vx = (FAST_SPEED *BallNum[0].vx) / STD_SPEED;
        BallNum[0].vy = (FAST_SPEED *BallNum[0].vy) / STD_SPEED;
        BallNum[1].vx = (FAST_SPEED *BallNum[1].vx) / STD_SPEED;
        BallNum[1].vy = (FAST_SPEED *BallNum[1].vy) / STD_SPEED;

        tBall.speed = tBall.speed + 5;
        if (tBall.speed > FAST_SPEED)
        {
            tBall.speed = FAST_SPEED;
        }
        return;
    }
    if (tItem == BALL_SLOWDOWN)
    {
        BallNum[0].vx = (STD_SPEED *BallNum[0].vx) / FAST_SPEED;
        BallNum[0].vy = (STD_SPEED *BallNum[0].vy) / FAST_SPEED;
        BallNum[1].vx = (STD_SPEED *BallNum[1].vx) / FAST_SPEED;
        BallNum[1].vy = (STD_SPEED *BallNum[1].vy) / FAST_SPEED;
        tBall.speed = tBall.speed - 5;
        if (tBall.speed < SLOW_SPEED)
        {
            tBall.speed = SLOW_SPEED;
        }
        return;
    }
    if (tItem == BALL_STKEXPAND)
    {
        if (tStick.Length <= STICK_MAXLENGTH)
        {
            tStick.Length = tStick.Length + 100;
            tStick.Left = tStick.Left - 50;
            tStick.lLength = tStick.Length;
            if (tStick.Left < AREA_LEFT - 10)
            {
                tStick.Left = AREA_LEFT - 10;
            }
            if (tStick.Left > AREA_RIGHT - tStick.Length + 10)
            {
                tStick.Left = AREA_RIGHT - tStick.Length + 10;
            }
        }
        return;
    }
    if (tItem == BALL_STKSRINK)
    {
        if (tStick.Length >= STICK_MINLENGTH)
        {
            BallNum[0].isDock = 0;
            BallNum[1].isDock = 0;
            tStick.Length = tStick.Length - 100;
            tStick.Left = tStick.Left + 50;
            tStick.lLength = tStick.Length;
            if (tStick.Left < AREA_LEFT - 10)
            {
                tStick.Left = AREA_LEFT - 10;
            }
            if (tStick.Left > AREA_RIGHT - tStick.Length + 10)
            {
                tStick.Left = AREA_RIGHT - tStick.Length + 10;
            }
        }
        return;
    }
    if (tItem == BALL_KILL)
    {
        IsAlive = 0;
        return;
    }
    if (tItem == BALL_SUPEREYE)
    {
        Box(37, 39, 90, 52, 1, 0);//debug
        Box(37, 39, 90, 52, 0, 1);
        TextOut(40, 40, "Finding", 0x41);

        for (i = 0; i < 11; i++)
        {
            for (j = 0; j < 11; j++)
            {
                if (Blocks[i][j] == 4)
                {
                    Blocks[i][j] = 1;
                    DrawBlock(i, j, 5);
                }
            }
        }
        Refresh();
        return;
    }
    if (tItem == BALL_GOODFOOD)
    {
        if (tStick.Length <= STICK_MAXLENGTH)
        {
            tStick.Left = tStick.Left - (STICK_MAXLENGTH - tStick.Length) / 2;
            tStick.Length = STICK_MAXLENGTH;

            tStick.lLength = tStick.Length;
            if (tStick.Left < AREA_LEFT - 10)
            {
                tStick.Left = AREA_LEFT - 10;
            }
            if (tStick.Left > AREA_RIGHT - tStick.Length + 10)
            {
                tStick.Left = AREA_RIGHT - tStick.Length + 10;
            }
        }
        tBall.MixProperty = tBall.MixProperty | BALL_RELIFE | BALL_THROUGH | BALL_FIRE | BALL_MAG;
        tBall.Strength = 3;
        return;
    }
    if (tItem == BALL_MAGIC)
    {
        Box(37, 39, 90, 52, 1, 0);//debug
        Box(37, 39, 90, 52, 0, 1);
        TextOut(40, 40, "Changing", 0x41);

        for (i = 0; i < 11; i++)
        {
            for (j = 0; j < 11; j++)
            {
                if (Blocks[i][j] == 2)
                {
                    Blocks[i][j] = 1;
                    DrawBlock(i, j, Blocks[i][j]);
                }
                if (Blocks[i][j] == 3)
                {
                    Blocks[i][j] = 2;
                    DrawBlock(i, j, Blocks[i][j]);
                    TotalBlock++;
                }
            }
        }
        Refresh();
        return;
    }

    if (tItem == BALL_RANDOM)
    {
        tItem = rand() % 12 + 129;
        goto GAIN_START;
    }
    if (tItem == BALL_DADLUCK)
    {
        tBall.MixProperty = 0;
        BallNum[0].vx = (FAST_SPEED *BallNum[0].vx) / STD_SPEED;
        BallNum[0].vy = (FAST_SPEED *BallNum[0].vy) / STD_SPEED;
        BallNum[1].vx = (FAST_SPEED *BallNum[1].vx) / STD_SPEED;
        BallNum[1].vy = (FAST_SPEED *BallNum[1].vy) / STD_SPEED;
        BallNum[0].isDock = 0;
        BallNum[1].isDock = 0;
        tBall.speed = tBall.speed + 5;
        if (tBall.speed > FAST_SPEED)
        {
            tBall.speed = FAST_SPEED;
        }
        if (tStick.Length >= STICK_MINLENGTH)
        {
            tStick.Length = STICK_MINLENGTH;
            tStick.Left = tStick.Left + (tStick.Length - STICK_MINLENGTH) / 2;
            tStick.lLength = tStick.Length;
            if (tStick.Left < AREA_LEFT - 10)
            {
                tStick.Left = AREA_LEFT - 10;
            }
            if (tStick.Left > AREA_RIGHT - tStick.Length + 10)
            {
                tStick.Left = AREA_RIGHT - tStick.Length + 10;
            }
        }
        tBall.Strength = 2;
        return;
    }

    if (tItem == BALL_LIFE)
    {
        if (++tBall.life > 14)
        {
            tBall.life = 14;
        }
        DrawLife(tBall.life);
        return;
    }
    if (tItem == BALL_FREEPASS)
    {
        TotalBlock = 0;
        return;
    }
    if (tItem == BALL_DOUBLE)
    {
        if (BallNum[1].visible == 0)
        {
            BallNum[1].visible = 1;
            BallNum[1].y = BallNum[0].y;

            BallNum[1].vx = BallNum[0].vx + 3;
            BallNum[1].vy = BallNum[0].vy + 3;
            BallNum[1].Bpox = BallNum[0].Bpox;
            BallNum[1].Bpoy = BallNum[0].Bpoy;
            if (BallNum[1].x >= (AREA_RIGHT - AREA_LEFT) / 2+AREA_LEFT)
            {
                BallNum[1].x = BallNum[0].x - 50;
            }
            else
            {
                BallNum[1].x = BallNum[0].x + 50;
            }
        }
        else
        if (BallNum[0].visible == 0)
        {
            BallNum[0].visible = 1;
            BallNum[0].vx = BallNum[1].vx + 3;
            BallNum[0].vy = BallNum[1].vy + 3;
            BallNum[0].y = BallNum[1].y;

            BallNum[0].Bpox = BallNum[1].Bpox;
            BallNum[0].Bpoy = BallNum[1].Bpoy;
            if (BallNum[0].x >= (AREA_RIGHT - AREA_LEFT) / 2+AREA_LEFT)
            {
                BallNum[0].x = BallNum[1].x - 20;
            }
            else
            {
                BallNum[0].x = BallNum[1].x + 20;
            }
        }
        return;
    }
}

int DoBargain(int score)
{
    if (TotalScore - score >=  - 2000)
    {
        TotalScore = TotalScore - score;
        CreateForm(39, Y0+18, 112, Y0+57, FORM_ANIM_EN, "Your Score:");
        ScoreToBuff(TotalScore);
        TextOut(44, Y0+26+FONT_H, Buff, 0x43);
        getchar();
        DrawScore();
        return 1;
    }
    CreateForm(39, Y0+18, 125, Y0+57, FORM_ANIM_EN, "Score Too Low");
    TextOut(44, Y0+26+FONT_H, "Can not buy!", 0x43);
    getchar();
    return 0;
}

void ShowSpeed()
{
    char select;
    strcpy(Buff[0], "Easy    ");
    strcpy(Buff[1], "Normal  ");
    strcpy(Buff[2], "Hard    ");
    strcpy(Buff[3], "Custom  ");
    CreateForm(45, Y0+5, 151, Y0+77, FORM_ANIM_EN, "Set Speed");
    TextOut(50, Y0+10+FONT_H, "Select Level:", 0x40);
    select = 3;
    if (DelayRate == 36) select = 0;
    if (DelayRate == 26) select = 1;
    if (DelayRate == 16) select = 2;
    select = CreateMenu(62, Y0+10+FONT_H*2, 4, select);
    if (select == 0)
    {
        DelayRate  = 36; //10   //PC
        FAST_SPEED = 25; //25
        STD_SPEED  = 20; //20
        SLOW_SPEED = 15; //15
    }
    else
    if (select == 1)
    {
        DelayRate  = 26; //10   //NC2000
        FAST_SPEED = 25; //25
        STD_SPEED  = 20; //20
        SLOW_SPEED = 15; //15
    }
    else
    if (select == 2)
    {
        DelayRate  = 16;  //4    //NC1020
        FAST_SPEED = 28; //28
        STD_SPEED  = 25; //25
        SLOW_SPEED = 20; //20
    }
    else
    if (select == 3)
    {
        Box(47, Y0+10+FONT_H, 149, Y0+72, 1, 0);
        TextOut(50, Y0+10+FONT_H, "Set Delay Value:", 0x40);
        DelayRate = CreateMoveBar(52, Y0+15+FONT_H * 2, 92, 100, DelayRate);
        if (DelayRate == 0)
        {
            DelayRate = 1;
        }
    }
    else
    {
        return;
    }
    NeedSave = 1;
}

int KeyMapping(int id)
{
    char ch;
    char i;
    for (;;)
    {
        Box(47, Y0+10+FONT_H, 149, Y0+72, 1, 0);
        TextOut(50, Y0+24+FONT_H, "Press a key...", 0x40);
        ch = getchar();
        if (ch == ESC_KEY)
        {
            return 0;
        }
        for (i = 0; i < sizeof(KeyMap); i++)
        {
            if (i != id && KeyMap[i] == ch)
            {
                break;
            }
        }
        if (i < sizeof(KeyMap))
        {
            TextOut(50, Y0+24+FONT_H * 1, "Already be used,", 0x40);
            TextOut(50, Y0+24+FONT_H * 2, "Please retry!", 0x40);
            getchar();
        }
        else
        {
            KeyMap[id] = ch;
            sprintf(Buff, "Key Value: %d", ch);
            TextOut(50, Y0+24+FONT_H * 2, Buff, 0x40);
            Delay(500);
            break;
        }
    }
    return 1;
}

void ShowKeys()
{
    char select, form_anim;
    select = 0;
    form_anim = FORM_ANIM_EN;
    for (;;)
    {
        strcpy(Buff[0], "Left    ");
        strcpy(Buff[1], "Right   ");
        strcpy(Buff[2], "Pause   ");
        strcpy(Buff[3], "Launch  ");
        strcpy(Buff[4], "Default ");
        CreateForm(45, Y0+5, 146, Y0+77, form_anim, "Set Keys");
        TextOut(50, Y0+10+FONT_H, "Choose a key:", 0x40);
        form_anim = FORM_ANIM_DIS;
        select = CreateMenu(62, Y0+10+FONT_H*2, 5, select);
        if (select <=3)
        {
            KeyMapping(select);
        }
        else
        if (select ==4)
        {
            CreateForm(51, Y0+23, 138, Y0+57, FORM_ANIM_EN, "Restore Keys");
            TextOut(57, Y0+31+FONT_H, "Load default!", 0x43);
            InitKeys();
            getchar();
        }
        else
        {
            break;
        }
        NeedSave = 1;
    }
}

void ShowClear()
{
    CreateForm(45, Y0+5, 159, Y0+77, FORM_ANIM_EN, "Clear High Score");
    TextOut(49, Y0+10+FONT_H * 1, "Warning:", 0x40);
    TextOut(49, Y0+10+FONT_H * 2, "The operation will", 0x40);
    TextOut(49, Y0+10+FONT_H * 3, "clear High Score!", 0x40);
    TextOut(49, Y0+13+FONT_H * 4, "<Enter> to confirm", 0x42);
    if (getchar() == ENTER_KEY)
    {
        ClearRanking();
        SaveRanking();
    }
}

void ShowOptions()
{
    char select, form_anim;
    
    form_anim = FORM_ANIM_EN;
    select = 0;
    NeedSave = 0;

    for(;;)
    {
        strcpy(Buff[0], "Speed   ");
        strcpy(Buff[1], "Keys    ");
        strcpy(Buff[2], "Clear   ");
        strcpy(Buff[3], "Return  ");
        CreateForm(4, Y0+8, 58, Y0+73, form_anim, "Options");
        form_anim = FORM_ANIM_DIS;
        select = CreateMenu(8, Y0+32, 4, select);
        if (select == 0)
        {
            ShowSpeed();
        }
        else
        if (select == 1)
        {
            ShowKeys();
        }
        else
        if (select == 2)
        {
            ShowClear();
        }
        else
        {
            if (NeedSave)
            {
                NeedSave = 0;
                SaveProfile();
            }
            break;
        }
        Refresh();
    }
}

void ShowShop()
{
    int score;
    char w, h;
    char form_anim, select, ch;
    form_anim = FORM_ANIM_EN;
    select = 1;
    for(;;)
    {
        strcpy(Buff[0], "Skip Lev");
        strcpy(Buff[1], "Life +1 ");
        strcpy(Buff[2], "Buy Item");
        strcpy(Buff[3], "Return  ");
        CreateForm(61, Y0+4, 144, Y0+64, form_anim, "Shop");
        form_anim = FORM_ANIM_DIS;
        select = CreateMenu(70, Y0+25, 4, select);
        //  ȷϸ
        if (select <= 1)
        {
            CreateForm(17, Y0+7, 131, Y0+69, FORM_ANIM_EN, Buff[select]);
            TextOut(20, Y0+25, "You need:", 0x43);
            if (select == 0)
                score = TotalBlock * 30;
            else
                score = 1000;
            sprintf(Buff, "Cost  %d score!", score);
            TextOut(25, Y0+25+FONT_H * 1, Buff, 0x43);
            TextOut(20, Y0+30+FONT_H * 2, "<Enter> to confirm", 0x42);
            ch = getchar();
            if (ch == ENTER_KEY)
            {
                if (DoBargain(score))
                {
                    if (select == 0 )
                    {
                        TotalBlock = 0;
                        return;
                    }
                    else
                    {
                        DrawLife(++tBall.life);
                    }
                }
            }
        }
        else
        // ߲˵
        if (select == 2)
        {
            CreateForm(17, Y0+7, 131, Y0+69, FORM_ANIM_DIS, "Buy Item");
            TextOut(25, Y0+25, "<              >", 0x43);
            //
            for (;;)
            {
                Box(60, Y0+25, 94, Y0+39, 1, 0);
                if (ItemID==7 || ItemID==9)
                {
                    w = 34;
                    h = 14;
                }
                else
                {
                    w = 28;
                    h = 11;
                }
                InitImageItem();
                WriteBlock(60, Y0+25, w, h, 0x41, ImgList[ItemID]);
                InitImageBlock();
                sprintf(Buff, "Cost: %d  ", Price[ItemID]*100);
                TextOut(46, Y0+30+FONT_H, Buff, 0x40);
                TextOut(20, Y0+30+FONT_H * 2, "<Enter> to confirm", 0x42);
                //
                ch = getchar();
                if (ch == ESC_KEY)
                {
                    break;
                }
                if (ch == LEFT_KEY)
                {
                    ItemID--;
                    if(ItemID>9) ItemID = 9;
                }
                else
                if (ch == RIGHT_KEY)
                {
                    ItemID++;
                    if(ItemID>9) ItemID = 0;
                }
                else
                if (ch == ENTER_KEY)
                {
                    if (DoBargain(Price[ItemID]*100))
                    {
                        Gain(Item[ItemID]);
                    }
                    break;
                }
            }
        }
        else
        // ϼ
        {
            break;
        }
        Refresh();
    }
}

void ShowSave()
{
    CreateForm(7, Y0+19, 126, Y0+59, FORM_ANIM_EN, NULL);
    if (MapType == 0)
    {
        if (MaxStage < CurStage)
        {
            MaxStage = CurStage;
        }
        sprintf(Buff, "Stage %d is Saved!", CurStage);
        TextOut(12, Y0+20+FONT_H, Buff, 0x40);
        SaveProfile();
    }
    else
    {
        TextOut(12, Y0+26, "Extern Map", 0x40);
        TextOut(12, Y0+26+FONT_H, "No need to save!", 0x40);
    }
    getchar();
}

int ShowPassword()
{
    char ch, pos;
    char pwd[9];
    // 
    CreateForm(24, Y0+29, 130, Y0+60, FORM_ANIM_EN, "Password");
    TextOut(29, Y0+47, "<Esc> to cancel", 0x41);
    pos = 0;
    for(;;)
    {
        ch = getchar();
        if (ch == ESC_KEY)
        {
            return 0;
        }
        if (ch == ENTER_KEY)
        {
            pos = 0;
        }
        else
        {
            Beep();
            pwd[pos] = ch;
            pwd[++pos] = 0;
            if (pos >= sizeof(pwd)-1) pos = 0;
            if (strcmp(pwd, "lifefull") == 0)
            {
                tBall.life = 14;
                DrawLife(tBall.life);
                return 1;
            }
            if (strcmp(pwd, "clearall") == 0)
            {
                TotalBlock = 0;
                return 1;
            }
            if (strcmp(pwd, "allstage") == 0)
            {
                MaxStage = TotalStage;
                return 1;
            }
        }// end for
    }
}

void MenuPause()
{
    char form_anim, select;
    
    form_anim = FORM_ANIM_EN;
    select = 1;

    for (;;)
    {
        strcpy(Buff[0], "Password");
        strcpy(Buff[1], "Shop    ");
        strcpy(Buff[2], "Save    ");
        strcpy(Buff[3], "Options ");
        strcpy(Buff[4], "Give up ");
        CreateForm(28, Y0+10, 120, Y0+71, form_anim, "Pause");
        form_anim = FORM_ANIM_DIS;
        select = CreateMenu(50, Y0+30, 5, select);
        if (select == 0)
        {
            if (ShowPassword())
            {
                return;
            }
        }
        else
        if (select == 1)
        {
            ShowShop();
        }
        else
        if (select == 2)
        {
            ShowSave();
        }
        else
        if (select == 3)
        {
            ShowOptions();
        }
        else
        if (select == 4)
        {
            isEsc = 1;
            return; //return to main menu
        }
        else
        {
            return; //return to game
        }
        if (TotalBlock == 0)
        {
            return; //return to game
        }
        Refresh();
    }
}

void BreakBrock(char nx, char ny, int y)
{
    if (Blocks[nx - 1][ny - 1] == 4)
    {
        Blocks[nx - 1][ny - 1] = 1;
        DrawBlock(nx - 1, ny - 1, 5);
        TotalScore = TotalScore + 2;
        DrawScore();
    }
    else
    {
        if (tBall.Strength == 3)
        {
            if (Blocks[nx - 1][ny - 1] < 3)
            {
                TotalBlock--;
            }
            Blocks[nx - 1][ny - 1] = 0;
            TotalScore = TotalScore + 8;
            DrawScore();
        }
        else
        {
            if (tBall.Strength >= Blocks[nx - 1][ny - 1])
            {
                Blocks[nx - 1][ny - 1]--;
                TotalScore = TotalScore + 2;
                DrawScore();
            }
            if (!Blocks[nx - 1][ny - 1])
            {
                TotalBlock--;
                TotalScore = TotalScore + 5;
                DrawScore();
                CreatItem(y);
            }
        }
        DrawBlock(nx - 1, ny - 1, Blocks[nx - 1][ny - 1]);
    }
}

int GameLoop()
{
    int x, y, i, j;
    char rx0, ry0, rx1, ry1;
    char notBallTurn;

    int Bpox, Bpoy, lBpox, lBpoy;
    int StkOffset, xOffset;
    char BallTurn;

    isEsc = 0;
Start:
    Block(122, LCD_H-38, 156, LCD_H-24, 0);
    Box(122, LCD_H-38, 156, LCD_H-24, 1, 0);

    tBall.speed = STD_SPEED;
    tBall.Strength = 2;
    tStick.Length = STICK_LENGTH;
    tStick.lLength = tStick.Length;
    tStick.Left = AREA_LEFT + (AREA_RIGHT + AREA_LEFT - tStick.Length) / 2;
    tStick.lLeft = tStick.Left;
    //////////////////
    tBall.MixProperty = 0;
    ////////////////
    gainITEM.itemID = 0;

    BallNum[0].isDock = 1;
    IsAlive = 1;
    StkOffset = tStick.Length / 2+50;

    BallTurn = 0;
    BallNum[0].y = STICK_HEIGHT - 20;
    BallNum[0].x = StkOffset + tStick.Left;
    BallNum[0].visible = 1;
    BallNum[0].Bpox = (BallNum[0].x + 70) / BLOCK_WIDTH;
    BallNum[0].Bpoy = (BallNum[0].y + 30) / BLOCK_HEIGHT;

    BallNum[1].y = STICK_HEIGHT + 20;
    BallNum[1].x = StkOffset + tStick.Left - 40;
    BallNum[1].vy = 0;
    BallNum[1].vx = 0;
    BallNum[1].visible = 0;

    BallNum[1].Bpox = (BallNum[1].x + 70) / BLOCK_WIDTH;
    BallNum[1].Bpoy = (BallNum[1].y + 30) / BLOCK_HEIGHT;

    DrawLife(tBall.life);
    while(CheckKey(128));
    while (IsAlive && TotalBlock > 0 && !isEsc)
    {
        if (Inkey() == ESC_KEY)
        {
            isEsc = 1;
        }
        if (CheckKey(KeyMap[2]))
        {
            MenuPause();
        }

        tStick.lLeft = tStick.Left;
        tStick.Left = tStick.Left + ((CheckKey(KeyMap[0])) - (CheckKey(KeyMap[1]))) *STICK_SPEED;
        if (tStick.Left < AREA_LEFT - 10)
        {
            tStick.Left = AREA_LEFT - 10;
        }
        if (tStick.Left > AREA_RIGHT - tStick.Length + 10)
        {
            tStick.Left = AREA_RIGHT - tStick.Length + 10;
        }

        BallTurn = 0;
    loop1:

        vx = BallNum[BallTurn].vx;
        vy = BallNum[BallTurn].vy;
        x = BallNum[BallTurn].x;
        y = BallNum[BallTurn].y;
        lBpox = BallNum[BallTurn].Bpox;
        lBpoy = BallNum[BallTurn].Bpoy;
        IsDock = BallNum[BallTurn].isDock;
        notBallTurn = BallTurn ^ 1;
        if (!BallNum[BallTurn].visible)
        {
            vx = 0;
            vy = 0;
        }

        if (IsDock)
        {
            x = x + tStick.Left - tStick.lLeft;
        }

        if (x > AREA_RIGHT)
        {
            vx =  - vx;
            x = AREA_RIGHT;
        }
        if (x < AREA_LEFT)
        {
            vx =  - vx;
            x = AREA_LEFT;
        }
        if (y < AREA_TOP)
        {
            vy =  - vy;
            y = AREA_TOP;
        }
        if (y >= STICK_HEIGHT - 20 && y < STICK_HEIGHT + 30)
        {
            StkOffset = x - tStick.Left;
            if (StkOffset <= tStick.Length + 20 && StkOffset + 20 >= 0)
            {
                Hits = 0;
                vx = 0;
                vy = 0;
                if (tBall.MixProperty &BALL_MAG)
                {
                    IsDock = 1;

                    y = STICK_HEIGHT - 20;
                    x = StkOffset + tStick.Left;
                    if (abs(x - BallNum[notBallTurn].x) < 20 && BallNum[notBallTurn].y == y)
                    {
                        if (x >= tStick.Left + tStick.Length / 2)
                        {
                            x = x - 20;
                            BallNum[notBallTurn].x = BallNum[notBallTurn].x + 10;
                        }
                        else
                        {
                            x = x + 20;
                            BallNum[notBallTurn].x = BallNum[notBallTurn].x - 10;
                        }
                    }
                }
                if (CheckKey(KeyMap[3]))
                {
                    IsDock = 0;
                }
                if (!IsDock)
                {
                    xOffset = StkOffset - tStick.Length / 2;
                    vx = tBall.speed * Sin(abs(xOffset) *100 / tStick.Length + 5) / 1024;
                    if (xOffset < 0)
                    {
                        vx =  - vx;
                    }
                    vy =  - tBall.speed * Cos(abs(xOffset) *100 / tStick.Length + 5) / 1024;
                }
            }
        }

        if (y >= STICK_HEIGHT + 40)
        {
            if (!(tBall.MixProperty &BALL_RELIFE))
            {
                BallNum[BallTurn].visible = 0;
                BallNum[BallTurn].vy = 0;
                BallNum[BallTurn].vx = 0;
                if (BallNum[0].visible == 0 &BallNum[1].visible == 0)
                {
                    IsAlive = 0;
                }
            }
            else
            {
                vy =  - vy;
                tBall.MixProperty = tBall.MixProperty - BALL_RELIFE;
            }
        }

        Bpox = (x + 70) / 100;
        Bpoy = (y + 30) / 50;

        if (abs(Bpox - lBpox) && abs(Bpoy - lBpoy))
        {
            if (Bpox && Bpox < 12 && Bpoy && Bpoy < 12 && Blocks[Bpox - 1][Bpoy - 1] && Blocks[Bpox - 1][Bpoy - 1] < 7 && (!Blocks[lBpox - 1][Bpoy - 1] || Blocks[lBpox - 1][Bpoy - 1] > 6) && (!Blocks[Bpox - 1][lBpoy - 1] || Blocks[Bpox - 1][lBpoy - 1] > 6))
            {
                BreakBrock(Bpox, Bpoy, y);

                if (!(tBall.MixProperty &BALL_THROUGH))
                {
                    Hits++;
                    vx =  - vx;
                    vy =  - vy;
                    x = x + vx + rand() %5 -2;
                    y = y + vy + rand() %5 -2;

                    Bpox = lBpox;
                    Bpoy = lBpoy;
                }
            }

            if (lBpox && lBpox < 12 && Bpoy && Bpoy < 12)
            {
                if (Blocks[lBpox - 1][Bpoy - 1] && Blocks[lBpox - 1][Bpoy - 1] < 7)
                {
                    BreakBrock(lBpox, Bpoy, y);

                    if (!(tBall.MixProperty &BALL_THROUGH))
                    {
                        Hits++;
                        vy =  - vy;
                        Bpoy = lBpoy;
                    }
                }
            }

            if (Bpox && Bpox < 12 && lBpoy && lBpoy < 12)
            {
                if (Blocks[Bpox - 1][lBpoy - 1] && Blocks[Bpox - 1][lBpoy - 1] < 7)
                {
                    BreakBrock(Bpox, lBpoy, y);

                    if (!(tBall.MixProperty &BALL_THROUGH))
                    {
                        Hits++;
                        vx =  - vx;
                        Bpox = lBpox;
                        x = x + vx + rand() %5 - 2;
                        y = y + vy + rand() %5 - 2;
                    }
                }
            }
        }
        else
        {
            if (Bpox && Bpox < 12 && Bpoy && Bpoy < 12)
            {
                if (Blocks[Bpox - 1][Bpoy - 1] && Blocks[Bpox - 1][Bpoy - 1] < 7)
                {
                    BreakBrock(Bpox, Bpoy, y);
                    if (!(tBall.MixProperty &BALL_THROUGH))
                    {
                        if (abs(Bpox - lBpox))
                        {
                            Hits++;
                            vx =  - vx;
                            Bpox = lBpox;
                            x = x + vx + rand() %5 - 2;
                            y = y + vy + rand() %5 - 2;
                        }
                        if (abs(Bpoy - lBpoy))
                        {
                            Hits++;
                            vy =  - vy;
                            Bpoy = lBpoy;
                            x = x + vx + rand() %5 - 2;
                            y = y + vy + rand() %5 - 2;
                        }
                    }
                }
            }
        }

        if (Bpox && Bpox < 12 && Bpoy && Bpoy < 12)
        {
            if (Blocks[Bpox - 1][Bpoy - 1] > 6)
            {
                if (!(tBall.MixProperty &BALL_THROUGH))
                {
                    i = vx;
                    j = vy;
                    if (Blocks[Bpox - 1][Bpoy - 1] == 8)
                    {
                        vy = abs(vy);
                        vy =  - vy;
                    }
                    if (Blocks[Bpox - 1][Bpoy - 1] == 7)
                    {
                        vy = abs(vy);
                    }
                    if (Blocks[Bpox - 1][Bpoy - 1] == 9)
                    {
                        vx = abs(vx);
                        vx =  - vx;
                    }
                    if (Blocks[Bpox - 1][Bpoy - 1] == 10)
                    {
                        vx = abs(vx);
                    }
                    if (i != vx || j != vy)
                    {
                        Hits++;
                    }
                }
            }
        }

        BallNum[BallTurn].vx = vx;
        BallNum[BallTurn].vy = vy;
        BallNum[BallTurn].x = x + vx;
        BallNum[BallTurn].y = y + vy;
        BallNum[BallTurn].Bpox = Bpox;
        BallNum[BallTurn].Bpoy = Bpoy;
        BallNum[BallTurn].isDock = IsDock;

        if (notBallTurn)
        {
            BallTurn = BallTurn + 1;
            goto loop1;
        }

        if (Hits > 100)
        {
            Hits = 0;

            tBall.MixProperty = tBall.MixProperty | BALL_THROUGH;
            BallNum[0].vx = (FAST_SPEED *BallNum[0].vx) / STD_SPEED;
            BallNum[0].vy = (FAST_SPEED *BallNum[0].vy) / STD_SPEED;
            BallNum[1].vx = (FAST_SPEED *BallNum[1].vx) / STD_SPEED;
            BallNum[1].vy = (FAST_SPEED *BallNum[1].vy) / STD_SPEED;

            tBall.speed = tBall.speed + 5;
            if (tBall.speed > FAST_SPEED)
            {
                tBall.speed = FAST_SPEED;
            }
            Box(37, 39, 95, 52, 1, 0);
            Box(37, 39, 95, 52, 0, 1);
            TextOut(40, 40, "100 Hits!", 0x41);
            Delay(500);
        }
        if (BallNum[0].visible)
        {
            rx0 = BallNum[0].x / 10 - 2;
            ry0 = BallNum[0].y / 10 - 2;
            GetBlock(rx0, ry0, 16, 4, 0, Buff[0]); //עǷ
        }
        if (BallNum[1].visible)
        {
            rx1 = BallNum[1].x / 10 - 2;
            ry1 = BallNum[1].y / 10 - 2;
            GetBlock(rx1, ry1, 16, 4, 0, Buff[1]); //עǷ
        }
        if (BallNum[0].visible)
        {
            WriteBlock(rx0, ry0, 4, 4, 0x03, ball);
        }
        if (BallNum[1].visible)
        {
            WriteBlock(rx1, ry1, 4, 4, 0x03, ball);
        }
        Rectangle(tStick.Left / 10, STICK_HEIGHT / 10, (tStick.Left + tStick.Length) / 10, STICK_HEIGHT / 10+1, 1);
        Refresh();
        Rectangle(tStick.Left / 10, STICK_HEIGHT / 10, (tStick.Left + tStick.Length) / 10, STICK_HEIGHT / 10+1, 0);
        if (BallNum[0].visible)
        {
            WriteBlock(rx0&~7, ry0, 16, 4, 0x01, Buff[0]);
        }
        if (BallNum[1].visible)
        {
            WriteBlock(rx1&~7, ry1, 16, 4, 0x01, Buff[1]);
        }
        if (gainITEM.itemID)
        {
            gainITEM.y = gainITEM.y + 8;
            gainITEM.x = gainITEM.x + rand() % 21 -10;
            if (gainITEM.x < AREA_LEFT + 4)
            {
                gainITEM.x = AREA_LEFT + 4;
            }
            if (gainITEM.x > AREA_RIGHT - 80)
            {
                gainITEM.x = AREA_RIGHT - 80;
            }
            if (gainITEM.y < STICK_HEIGHT + 10 && gainITEM.y > STICK_HEIGHT - 30)
            {
                if ((gainITEM.x >= tStick.Left && gainITEM.x <= tStick.Left + tStick.Length) || (gainITEM.x + 8 >= tStick.Left && gainITEM.x + 8 <= tStick.Left + tStick.Length))
                {
                    Gain(gainITEM.itemID);
                    TotalScore = TotalScore + 50;
                    DrawScore();
                    gainITEM.itemID = 0;

                    Block(122, LCD_H-38, 156, LCD_H-24, 0);
                    Box(122, LCD_H-38, 156, LCD_H-24, 1, 0);
                }
            }
            if (gainITEM.y > STICK_HEIGHT + 20)
            {
                gainITEM.itemID = 0;

                Block(122, LCD_H-38, 156, LCD_H-24, 0);
                Box(122, LCD_H-38, 156, LCD_H-24, 1, 0);

            }
            Box(gainITEM.x / 10-4, gainITEM.y / 10, gainITEM.x / 10+4, gainITEM.y / 10+3, 0, 2);
        }
/* debug
        if (BallNum[0].visible)
        {
            WriteBlock(BallNum[0].x / 10-2, BallNum[0].y / 10-2, 4, 4, 0x43, ball);
        }
        if (BallNum[1].visible)
        {
            WriteBlock(BallNum[1].x / 10-2, BallNum[1].y / 10-2, 4, 4, 0x43, ball);
        }
        Box(tStick.Left / 10, STICK_HEIGHT / 10, (tStick.Left + tStick.Length) / 10, STICK_HEIGHT / 10+1, 0, 1);
*/
        if (DelayRate >= 4)
        {
            Delay(DelayRate);
        }
    }

    if (!IsAlive)
    {
        TextOut(30, 60, "You Miss!", 0x43);
        Box(1, 0, LCD_W, LCD_H, 1, 2);

        getchar();
        tBall.life--;
        if (tBall.life > 0)
        {
            goto Start;
        }
        else
        {
            Refresh();
            CreateForm(32, Y0+18, 105, Y0+57, FORM_ANIM_EN, ":-(");
            TextOut(40, Y0+26+FONT_H, "Game Over!", 0x43);
            getchar();
        }
    }
    if (TotalBlock <= 0 && tBall.life > 0)
    {
        TextOut(30, 60, "Stage Clear!", 0x43);
        Box(0, 0, LCD_W, LCD_H, 1, 2);
        getchar();
        Box(0, 0, LCD_W, LCD_H, 1, 2);
        return 1;
    }
    return 0;
}

void ShowError(addr str)
{
    if (fp != 0)
    {
        fclose(fp);
    }
    CreateForm(39, Y0+22, 124, Y0+57, FORM_ANIM_EN, "Error!");
    TextOut(45, Y0+30+FONT_H, str, 0x43);
    getchar();
}

void ShowRanking()
{
    char i;
    ClearScreen();
    Refresh();
    CreateForm(2, Y0+2, 157, Y0+78, FORM_ANIM_EN, "High Score TOP 3");
    for (i = 0; i < 3; i++)
    {
        TextOut(12, Y0+5+(FONT_H+FONT_H/2) *(i + 1), RankNames[i], 0x43);
        ScoreToBuff(HighScores[i]);
        TextOut(84, Y0+5+(FONT_H+FONT_H/2) *(i + 1), Buff, 0x43);
    }
    getchar();
}

void CheckRanking()
{
    char i, j;
    if (TotalScore > 999999)
    {
        TotalScore = 999999;
    }
    CreateForm(50, Y0+30, 123, Y0+69, FORM_ANIM_EN, "Your Score");
    ScoreToBuff(TotalScore);
    TextOut(56, Y0+38+FONT_H, Buff, 0x43);
    getchar();

    for (i = 0; i < 3; i++)
    {
        if (TotalScore > HighScores[i])
        {
            for (j = 2; j > i; j--)
            {
                HighScores[j] = HighScores[j - 1];
                strcpy(RankNames[j], RankNames[j-1]);
            }
            CreateForm(17, Y0+7, 128, Y0+60, FORM_ANIM_EN, "Get High Score!");
            TextOut(22, Y0+12+FONT_H, "Input Name:", 0x43);
            Box(20, Y0+17+FONT_H * 2-1, 125, Y0+17+FONT_H * 3, 0, 1);
            Input(23, Y0+17+FONT_H * 2, RankNames[i], 9);
            HighScores[i] = TotalScore;
            SaveRanking();
            break;
        }
    }
}

int SelectStage(char max)
{
    char ch;
    if (max <= 1 )
    {
        CurStage = 1;
        return 1;
    }
    if (max > TotalStage)
    {
        max = TotalStage;
    }
    if (CurStage < 1)
    {
        CurStage = 1;
    }
    CreateForm(15, Y0+10, 130, Y0+70, FORM_ANIM_EN, "Select Stage");
    for(;;)
    {
        sprintf(Buff, "Stage: %d   ", CurStage);
        TextOut(21, Y0+13+FONT_H * 2, Buff, 0x40);
        TextOut(19, Y0+18+FONT_H * 3, "<Enter> to confirm", 0x42);
        ch = getchar();
        if (ch == ENTER_KEY)
        {
            return CurStage;
        }
        if (ch == ESC_KEY)
        {
            break;
        }
        if (ch == LEFT_KEY)  CurStage--;
        if (ch == RIGHT_KEY) CurStage++;
        if (ch == UP_KEY)    CurStage = CurStage - 10;
        if (ch == DOWN_KEY)  CurStage = CurStage + 10;
        if (CurStage < 1)    CurStage = max;
        if (CurStage > max)  CurStage = 1;
    }
    return 0;
}

void ShowAbout()
{
    ClearScreen();
    Refresh();
    CreateForm(10, Y0+6, 150, Y0+75, FORM_ANIM_EN, "Crazyball v2.4 Final");
    TextOut(15, Y0+11+FONT_H, "Reprogram by SnoopyZZ", 0x41);
    TextOut(15, Y0+11+FONT_H * 2, "Tiny Edition", 0x41);
    sprintf(Buff, "Licensed to:%s", UserName);
    TextOut(15, Y0+11+FONT_H * 3, Buff, 0x41);
    TextOut(15, Y0+11+FONT_H * 4, "Copyright CSKSOFT 2004", 0x49);
    getchar();
}

int MenuMain()
{
    char select;

    select = 0;
    for (;;)
    {
        // 
        ClearScreen();
        Refresh();
        // ˵
        CreateForm(11, Y0+3, 138, Y0+77, FormAnim|FORM_DRAW_BUF, NULL);
        FormAnim = FORM_ANIM_DIS;
        WriteBlock(20, Y0+7, 109, 28, 1, logo1); //logo 109 28
    
        strcpy(Buff[0], "Start   ");
        strcpy(Buff[1], "Ext.Map ");
        strcpy(Buff[2], "Options ");
        strcpy(Buff[3], "Ranking ");
        strcpy(Buff[4], "About...");
    
        select = CreateMenu(50, Y0+38, 5, select|FORM_DRAW_BUF);
        if (select == 0)
        {
            if (MapType != 0)
            {
                MapType = 0;
                CurStage = 1;
            }
            strcpy(StageFile, "/LavaData/CBallDat.dat");
            fp = fopen(StageFile, "rb");
            if (fp == 0)
            {
                ShowError("No CBallDat?");
                continue;
            }
            if (fread(Buff, 1, 8, fp) == 0)
            {
                ShowError("Can not read");
                continue;
            }
            fclose(fp);
            //
            TotalStage = Buff[0][0];
            Buff[0][8] = 0;
            if (strcmp(&Buff[0][1], "MAINA") != 0)
            {
                ShowError("Wrong format");
                continue;
            }
            //
            TotalScore = 0;
            if (SelectStage(MaxStage) > 0)
            {
                return 1;
            }
        }
        else
        if (select == 1)
        {
            if (MapType == 0)
            {
                CurStage = 1;
            }
            MapType = 0;
            //for (;;)//debug
            {
                /* debug
                ChDir("/LavaData");
                if (!FileList(StageFile))
                {
                    break;
                }*/
                strcpy(StageFile, "/LavaData/CBallExt.dat");
                fp = fopen(StageFile, "rb");
                if (fp == 0)
                {
                    ShowError("Can not open");
                    continue;
                }
                if (fread(Buff, 1, 8, fp) == 0)
                {
                    ShowError("Can not read");
                    continue;
                }
                fclose(fp);
                //
                TotalStage = Buff[0][0];
                Buff[0][8] = 0;
                if (strcmp(&Buff[0][1], "MAIN") != 0)
                {
                    ShowError("Wrong format");
                    continue;
                }
                MapType = 1;
                //break;debug
            }
            if (MapType == 0)
            {
                continue;
            }
            //
            TotalScore = 0;
            if (SelectStage(TotalStage) > 0)
            {
                return 2;
            }
        }
        else
        if (select == 2)
        {
            ShowOptions();
        }
        else
        if (select == 3)
        {
            ShowRanking();
        }
        else
        if (select == 4)
        {
            ShowAbout();
        }
        else
        {// Cancel
            return 0;
        }
    }
    // Error
    return 0;
}

void main()
{
    DelayRate = Getms();
    ClearScreen();
    //
    TextOut(56, Y0+24, "CSKSOFT", 1);
    TextOut(56, Y0+39, "Present", 1);
    TextOut(20, Y0+60, "Reprogram by SnoopyZZ", 1);
    Refresh();
    Delay(300);
    //
    LoadProfile();
    srand(Getms()*DelayRate);
    //
    FormAnim = FORM_ANIM_EN;
    for (;;)
    {
        if (MenuMain() == 0)
        {
            break;
        }
        InitImageBlock();
        DrawSence();
        tBall.life = 3;
    
        for (;;)
        {
            if (CurStage <= TotalStage)
            {
                LoadStage(CurStage);
                if (GameLoop() == 0)
                {
                    break;
                }
                CurStage++;
            }
            else
            {
                CreateForm(17, Y0+12, 130, Y0+60, FORM_ANIM_EN, "Congratulation");
                TextOut(23, Y0+24+FONT_H, "All stage clear!", 0x41);
                if (MapType == 0)
                {
                    MaxStage = TotalStage;
                }
                getchar();
                break;
            }
        }
        if (isEsc == 0)
        {
            SaveProfile();
            CheckRanking();
            ShowRanking();
        }
    }
}
